<!-- 任务列表 -->

<template>
  <div style="position: relative">
    <vxe-table border show-header-overflow show-overflow :row-config="{ isHover: true }" :data="myDataSetPage.tableData.impl.dataList" min-height="96">
      <vxe-column field="taskId" title="任务ID"></vxe-column>
      <vxe-column field="modelVersion" title="模型版本">
        <template slot-scope="scope">V{{scope.row.modelVersion  }}</template>
      </vxe-column>
      <vxe-column field="taskType" title="任务类型">
        <template slot-scope="scope">
          {{ TaskType.getValue(scope.row.taskType) }}

        </template>
      </vxe-column>
      <vxe-column field="taskStatus" title="任务状态">
        <template slot-scope="scope">
          {{ TaskStatus.getValue(scope.row.taskStatus) }}
        </template>
      </vxe-column>
      <vxe-column field="createTime" title="创建时间"></vxe-column>
      <vxe-column field="completeTime" title="完成时间"></vxe-column>
      <vxe-column field="operation" title="操作">
        <template slot-scope="scope">

          <el-button type="text" :size="defaultFormItemSize" @click="particulars(scope.row)">详情</el-button>
          <!-- <el-button type="text" :size="defaultFormItemSize" >评估</el-button>
          <el-button type="text" :size="defaultFormItemSize" >部署</el-button>
          <el-button type="text" :size="defaultFormItemSize" @click="del(scope.row)">删除</el-button> -->
        </template>
      </vxe-column>
    </vxe-table>
    <el-row slot="pagination" type="flex" justify="end" style="margin-top: 16px;width: 100%;">
      <el-pagination :total="myDataSetPage.tableData.impl.totalCount" :current-page="myDataSetPage.tableData.impl.currentPage" :page-size="myDataSetPage.tableData.impl.pageSize" :page-sizes="[10, 20, 50, 100]" layout="total, prev, pager, next, sizes" @current-change="myDataSetPage.tableData.impl.onCurrentPageChange" @size-change="myDataSetPage.tableData.impl.onPageSizeChange">
      </el-pagination>
    </el-row>

  </div>
</template>
  
<script>
import { mapGetters } from 'vuex'
/* eslint-disable-next-line */
import { DropdownWidget, TableWidget, UploadWidget, ChartWidget } from '@/utils/widget.js'
import { ModelTask } from '@/api/gptController.js'
// import editOrAdd from './dialog/editOrAdd';
import particulars from '@/views/gptTraining/modelManagement/modelEvaluation/dialog/particulars.vue'
import modelCompressionParticulars from '@/views/gptTraining/modelManagement/modelCompression/dialog/particulars.vue'
export default {
  data() {
    return {
      myDataSetPage: {
        formFilter: {},

        tableData: {
          impl: new TableWidget(this.getwidgetData, true, true, false, undefined, false)
        }
      }
    }
  },

  components: {},
  props: ['tableItem'],
  computed: {
    ...mapGetters(['getMainContextHeight']),
    tableHeight() {
      return this.getMainContextHeight - 95 + 'px'
    }
  },

  methods: {
    getwidgetData(params) {
      if (params == null) params = {}
      params = {
        ...params,
        // orderParam: [
        //   {
        //     asc: true,
        //     dateAggregateBy: '',
        //     fieldName: ''
        //   }
        // ],
        // pageParam: {
        //   pageNum: 0,
        //   pageSize: 0
        // },

        modelTaskDtoFilter: { modelId: this.tableItem.modelId }
      }

      return new Promise((resolve, reject) => {
        ModelTask.list(this, params)
          .then((res) => {
            resolve({
              dataList: res.data.dataList,
              totalCount: res.data.totalCount
            })
          })
          .catch((e) => {
            reject(e)
          })
      })
    },
    // add () {
    //   this.$dialog.show('创建模版', editOrAdd, {
    //     area: ['100%', '100%']
    //   }, { isEdit: false }).then(res => {
    //     this.refresh();
    //   }).catch(e => { });
    // },
    // edit (item) {
    //   this.$dialog.show('修改模版', editOrAdd, {
    //     area: ['100%', '100%']
    //   }, { isEdit: true, item: item }).then(res => {
    //     this.refresh();
    //   }).catch(e => { });
    // },
    del(item) {
      this.$confirm('是否确认删除', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        let params = { versionId: item.versionId }
        ModelTask.delete(this, params)
          .then((res) => {
            this.$message.success('删除成功')
            this.refresh()
          })
          .catch((e) => {
            console.log(e)
          })
      })
    },
    particulars(item) {
      console.log(item, item.taskType)
      if (item.taskType === 2) {
        // 模型压缩
        this.$dialog
          .show(
            '模型压缩详情',
            modelCompressionParticulars,
            {
              area: ['100%', '100%']
            },
            { item: item.modelCompress }
          )
          .then((res) => {
            this.refresh()
          })
          .catch((e) => {})
      } else {
        this.$dialog
          .show(
            '模型评估详情',
            particulars,
            {
              area: ['100%', '100%']
            },
            { item: item.modelEstimate }
          )
          .then((res) => {
            this.refresh()
          })
          .catch((e) => {})
      }
    },
    refresh(reloadData = false) {
      if (reloadData) {
        this.myDataSetPage.tableData.impl.refreshTable(true, 1)
      } else {
        this.myDataSetPage.tableData.impl.refreshTable()
      }
    },
    onReset() {
      this.$refs.myDataSetPage.resetFields()
      this.refresh(true)
    },
    formInit() {
      this.refresh()
    }
  },

  mounted() {
    this.formInit()
  }
}
</script>
<style lang="scss" scoped>
@import '@/assets/style/element-variables.scss';

.topBox {
  background-color: white;
  width: 100%;
  height: 95px;
  margin-bottom: 16px;

  .title {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
    padding: 20px 20px 10px 20px;
  }
}

.instructions {
  padding: 0px 20px 20px 20px;

  .describe {
    color: $--color-text-secondary;
    margin-bottom: 16px;
  }

  .itemTitle {
    color: $--color-text-primary;
    font-size: 16px;
    font-weight: 500;
    margin-bottom: 8px;
  }

  .head-index {
    font-size: 24px;
    color: #e8e9eb;
    line-height: 32px;
  }

  .itemDescribe {
    width: 170px;
    color: $--color-text-secondary;
  }

  .img {
    height: 72px;
    width: 140px;
  }
}

.tableBox {
  background-color: white;
  width: 100%;
  padding: 20px;
  overflow: auto;
  .add {
    margin-bottom: 20px;
  }
}
</style>
